/*
  Hangul Automata Program for nemacs
*/

#include <stdio.h>

#define push(x)	( stack[ sp++ ] = (x) )
#define pop()	( stack[ --sp ] )

typedef unsigned char Char;

int hangul_state;
Char temp_hangul[3];

main()
{
    char str[10];
    Char buf[10];
    int n;

    while (1) {
	gets(str);
	switch (str[0]) {
	case 't':		/* toggle */
	    hangul_automata(-1, buf);
	    n = 0;
	    break;
	case 'r':		/* restart */
	    hangul_automata(-2, buf);
	    n = 0;
	    break;
	case 'i':		/* insert */
	    n = hangul_automata(str[1], buf);
	}
	if (n > 0) {
	    buf[n] = 0;
	    printf("i%s\n", buf); /* insert */
	}
	if (temp_hangul[0])
	    printf("d%s\n", temp_hangul); /* display */
    }
}

static int fcon( c )
    int c;
{
    switch (c) {
    case 'r':
	return 1 + 128;
    case 'R':
	return 2 + 128;
    case 's':
	return 3 + 128;
    case 'e':
	return 4 + 128;
    case 'E':
	return 5 + 128;
    case 'f':
	return 6 + 128;
    case 'a':
	return 7 + 128;
    case 'q':
	return 8 + 128;
    case 'Q':
	return 9 + 128;
    case 't':
	return 10 + 128;
    case 'T':
	return 11 + 128;
    case 'd':
	return 12 + 128;
    case 'w':
	return 13 + 128;
    case 'W':
	return 14 + 128;
    case 'c':
	return 15 + 128;
    case 'z':
	return 16 + 128;
    case 'x':
	return 17 + 128;
    case 'v':
	return 18 + 128;
    case 'g':
	return 19 + 128;
    default:
	return 0;
    }
}

static int vow( c )
    int c;
{
    switch (c) {
    case 'k':
	return 1 + 128;
    case 'o':
	return 2 + 128;
    case 'i':
	return 3 + 128;
    case 'O':
	return 4 + 128;
    case 'j':
	return 5 + 128;
    case 'p':
	return 6 + 128;
    case 'u':
	return 7 + 128;
    case 'P':
	return 8 + 128;
    case 'h':
	return 9 + 128;
    case 'y':
	return 13 + 128;
    case 'n':
	return 14 + 128;
    case 'b':
	return 18 + 128;
    case 'm':
	return 19 + 128;
    case 'l':
	return 21 + 128;
    default:
	return 0;
    }
}

static int lcon( c )
    int c;
{
    switch (c) {
    case 'r':
	return 1 + 128;
    case 'R':
	return 2 + 128;
    case 's':
	return 4 + 128;
    case 'e':
	return 7 + 128;
    case 'f':
	return 8 + 128;
    case 'a':
	return 16 + 128;
    case 'q':
	return 17 + 128;
    case 't':
	return 19 + 128;
    case 'T':
	return 20 + 128;
    case 'd':
	return 21 + 128;
    case 'w':
	return 22 + 128;
    case 'c':
	return 23 + 128;
    case 'z':
	return 24 + 128;
    case 'x':
	return 25 + 128;
    case 'v':
	return 26 + 128;
    case 'g':
	return 27 + 128;
    default:
	return 0;
    }
}

static int comcon( k, c )
    int k;
    int c;
{
    switch (k) {
    case 1 + 128:
	switch (c) {
	case 't':
	    return 3 + 128;
	}
	break;
    case 4 + 128:
	switch (c) {
	case 'w':
	    return 5 + 128;
	case 'g':
	    return 6 + 128;
	}
	break;
    case 8 + 128:
	switch (c) {
	case 'r':
	    return 9 + 128;
	case 'a':
	    return 10 + 128;
	case 'q':
	    return 11 + 128;
	case 't':
	    return 12 + 128;
	case 'x':
	    return 13 + 128;
	case 'v':
	    return 14 + 128;
	case 'g':
	    return 15 + 128;
	}
	break;
    case 17 + 128:
	switch (c) {
	case 't':
	    return 18 + 128;
	}
	break;
    }
    return 0;
}

static int comvow( v, c )
    int v;
    int c;
{
    switch (v) {
    case 9 + 128:
	switch (c) {
	case 'k':
	    return 10 + 128;
	case 'o':
	    return 11 + 128;
	case 'l':
	    return 12 + 128;
	}
	break;
    case 14 + 128:
	switch (c) {
	case 'j':
	    return 15 + 128;
	case 'p':
	    return 16 + 128;
	case 'l':
	    return 17 + 128;
	}
	break;
    case 19 + 128:
	switch (c) {
	case 'l':
	    return 20 + 128;
	}
	break;
    }
    return 0;
}

ascii(c, buf)
    int c;
    char *buf;
{
    if (c == -1) {
	if (hangul_state)
	    hangul_state = 0;
	else
	    hangul_state = 1;
	return 0;
    }
    else if (c == -2) {
	return 0;
    }
    else {
	buf[0] = c;
	return 1;
    }
}

hangul_automata(c, buf)
    int c;		/* input character */
    char *buf;
{
    static int sp, pc, f, m, l, stack[10];
    int t;

    switch ( hangul_state ) {
    case 0:
	return ascii(c, buf);
	break;
    case 1:
	sp = 0;
	if ( t = fcon(c) ) {
	    display_temp(t, 0x80, 0x80);
	    f = t;
	    hangul_state = 2;
	    return 0;
	}
	else if ( t = vow(c) ) {
	    convert_3_to_ks(0x80, t, 0x80, buf);
	    return 2;
	}
	else {
	    return ascii(c, buf);
	}
	break;
    case 2:
	if ( t = vow(c) ) {
	    display_temp(f, t, 0x80);
	    push( 0x80 );
	    m = t;
	    hangul_state = 3;
	    return 0;
	}
	else if ( t = fcon(c) ) {
	    convert_3_to_ks(f, 0x80, 0x80, buf);
	    display_temp(t, 0x80, 0x80);
	    sp = 0;
	    f = t;
	    hangul_state = 2;
	    return 2;
	}
	else if (c == '\b') {
	    display_temp(-1, -1, -1);
	    hangul_state = 1;
	    return 0;
	}
	else {
	    convert_3_to_ks(f, 0x80, 0x80, buf);
	    display_temp(-1, -1, -1, 0);
	    hangul_state = 1;
	    return ascii(c, buf+2)+2;
	}
	break;
    case 3:
	if ((t = lcon(c)) && in_ks(f, m, t)) {
	    display_temp(f, m, t);
	    push( 128 );
	    l = t;
	    pc = c;
	    hangul_state = 4;
	    return 0;
	}
	else if (t = comvow(m, c)) {
	    display_temp(f, t, 0x80);
	    push( m );
	    m = t;
	    return 0;
	}
	else if (t = fcon(c)) {
	    convert_3_to_ks(f, m, 0x80, buf);
	    display_temp(t, 0x80, 0x80);
	    f = t;
	    sp = 0;
	    hangul_state = 2;
	    return 2;
	}
	else if (t = vow(c)) {
	    convert_3_to_ks(f, m, 0x80, buf);
	    convert_3_to_ks(0x80, t, 0x80, buf+2);
	    display_temp(-1, -1, -1);
	    hangul_state = 1;
	    return 4;
	}
	else if (c == '\b') {	/* back space */
	    m = pop();
	    display_temp(f, m, 0x80);
	    if (m == 0x80) /* we extracted all */
		hangul_state = 2;
	    return 0;
	}
	else {
	    convert_3_to_ks(f, m, 0x80, buf);
	    display_temp(-1, -1, -1);
	    sp = 0;
	    hangul_state = 1;
	    return ascii(c, buf+2)+2;
	}
	break;
    case 4:
	if ((t = comcon(l, c)) && in_ks(f, m, t)) {
	    display_temp(f, m, t);
	    push( l );
	    l = t;
	    pc = c;
	    return 0;
	}
	else if (t = vow(c)) {
	    convert_3_to_ks(f, m, pop(), buf);
	    display_temp(f = fcon(pc), m = t, 0x80);
	    sp = 0;
	    push( 128 );
	    hangul_state = 3;
	    return 2;
	}
	else if (t = fcon(c)) {
	    convert_3_to_ks(f, m, l, buf);
	    display_temp(t, 0x80, 0x80);
	    f = t;
	    sp = 0;
	    hangul_state = 2;
	    return 2;
	}
	else if (c == '\b') {	/* back space */
	    display_temp(f, m, l = pop());
	    if (l == 0x80)
		hangul_state = 3;
	    return 0;
	}
	else {
	    convert_3_to_ks(f, m, l, buf);
	    display_temp(-1, -1, -1);
	    sp = 0;
	    hangul_state = 1;
	    return ascii(c,buf+2)+2;
	}
	break;
    }
}

display_temp(f, m, l)
    int f, m, l;
{
    if (f < 0) {
	temp_hangul[0] = 0;
    }
    else {
	convert_3_to_ks(f, m, l, temp_hangul);
    }
}

in_ks(f, m, t)
    int f, m, t;
{
    char buf[2];

    return convert_3_to_ks(f, m, t, buf);
}

#define index(h, l)	(((h)-0xb0)*(0xff-0xa1)+((l)-0xa1))

static unsigned char ks_table1[][3] = {
  129, 129, 128,  129, 129, 129,  129, 129, 132,
  129, 129, 135,  129, 129, 136,  129, 129, 137,
  129, 129, 138,  129, 129, 144,  129, 129, 145,
  129, 129, 146,  129, 129, 147,  129, 129, 148,
  129, 129, 149,  129, 129, 150,  129, 129, 151,
  129, 129, 153,  129, 129, 154,  129, 129, 155,
  129, 130, 128,  129, 130, 129,  129, 130, 132,
  129, 130, 136,  129, 130, 144,  129, 130, 145,
  129, 130, 147,  129, 130, 148,  129, 130, 149,
  129, 131, 128,  129, 131, 129,  129, 131, 132,
  129, 131, 136,  129, 131, 147,  129, 131, 149,
  129, 132, 128,  129, 132, 132,  129, 132, 136,
  129, 133, 128,  129, 133, 129,  129, 133, 132,
  129, 133, 135,  129, 133, 136,  129, 133, 138,
  129, 133, 144,  129, 133, 145,  129, 133, 147,
  129, 133, 148,  129, 133, 149,  129, 133, 150,
  129, 133, 153,  129, 133, 154,  129, 133, 155,
  129, 134, 128,  129, 134, 132,  129, 134, 136,
  129, 134, 144,  129, 134, 145,  129, 134, 147,
  129, 134, 148,  129, 134, 149,  129, 135, 128,
  129, 135, 129,  129, 135, 130,  129, 135, 132,
  129, 135, 135,  129, 135, 136,  129, 135, 144,
  129, 135, 145,  129, 135, 147,  129, 135, 148,
  129, 135, 149,  129, 135, 153,  129, 136, 128,
  129, 136, 132,  129, 136, 136,  129, 136, 145,
  129, 136, 147,  129, 137, 128,  129, 137, 129,
  129, 137, 132,  129, 137, 135,  129, 137, 136,
  129, 137, 138,  129, 137, 140,  129, 137, 143,
  129, 137, 144,  129, 137, 145,  129, 137, 147,
  129, 137, 149,  129, 137, 150,  129, 138, 128,
  129, 138, 129,  129, 138, 132,  129, 138, 136,
  129, 138, 138,  129, 138, 144,  129, 138, 145,
  129, 138, 147,  129, 138, 149,  129, 139, 128,
  129, 139, 132,  129, 139, 136,  129, 139, 145,
  129, 139, 148,  129, 139, 149,  129, 140, 128,
  129, 140, 129,  129, 140, 132,  129, 140, 136,
  129, 140, 144,  129, 140, 145,  129, 140, 147,
  129, 140, 149,  129, 141, 128,  129, 141, 132,
  129, 141, 136,  129, 141, 145,  129, 141, 147,
  129, 142, 128,  129, 142, 129,  129, 142, 132,
  129, 142, 135,  129, 142, 136,  129, 142, 137,
  129, 142, 138,  129, 142, 143,  129, 142, 144,
  129, 142, 145,  129, 142, 147,  129, 142, 149,
  129, 142, 150,  129, 143, 128,  129, 143, 129,
  129, 143, 132,  129, 143, 136,  129, 143, 148,
  129, 143, 149,  129, 144, 128,  129, 144, 147,
  129, 145, 128,  129, 145, 129,  129, 145, 132,
  129, 145, 136,  129, 145, 144,  129, 145, 145,
  129, 145, 147,  129, 146, 128,  129, 146, 132,
  129, 146, 136,  129, 147, 128,  129, 147, 129,
  129, 147, 132,  129, 147, 135,  129, 147, 136,
  129, 147, 137,  129, 147, 144,  129, 147, 145,
  129, 147, 147,  129, 147, 149,  129, 148, 128,
  129, 149, 128,  129, 149, 129,  129, 149, 132,
  129, 149, 135,  129, 149, 136,  129, 149, 138,
  129, 149, 144,  129, 149, 145,  129, 149, 147,
  129, 149, 149,  129, 149, 150,  129, 149, 154,
  130, 129, 128,  130, 129, 129,  130, 129, 130,
  130, 129, 132,  130, 129, 136,  130, 129, 138,
  130, 129, 144,  130, 129, 145,  130, 129, 147,
  130, 129, 148,  130, 129, 149,  130, 129, 153,
  130, 130, 128,  130, 130, 129,  130, 130, 132,
  130, 130, 136,  130, 130, 144,  130, 130, 145,
  130, 130, 147,  130, 130, 148,  130, 130, 149,
  130, 131, 128,  130, 131, 129,  130, 131, 136,
  130, 133, 128,  130, 133, 129,  130, 133, 130,
  130, 133, 132,  130, 133, 136,  130, 133, 144,
  130, 133, 145,  130, 133, 147,  130, 133, 148,
  130, 133, 149,  130, 134, 128,  130, 134, 129,
  130, 134, 132,  130, 134, 144,  130, 134, 147,
  130, 134, 149,  130, 135, 128,  130, 135, 132,
  130, 135, 136,  130, 135, 147,  130, 135, 148,
  130, 135, 153,  130, 136, 128,  130, 137, 128,
  130, 137, 129,  130, 137, 132,  130, 137, 134,
  130, 137, 136,  130, 137, 144,  130, 137, 145,
  130, 137, 147,  130, 137, 149,  130, 137, 150,
  130, 137, 151,  130, 138, 128,  130, 138, 129,
  130, 138, 136,  130, 138, 148,  130, 138, 149,
  130, 139, 128,  130, 139, 129,  130, 139, 149,
  130, 140, 128,  130, 140, 132,  130, 140, 136,
  130, 140, 144,  130, 140, 145,  130, 140, 149,
  130, 141, 128,  130, 142, 128,  130, 142, 129,
  130, 142, 132,  130, 142, 136,  130, 142, 143,
  130, 142, 144,  130, 142, 145,  130, 142, 147,
  130, 142, 149,  130, 142, 150,  130, 143, 128,
  130, 143, 136,  130, 143, 148,  130, 143, 149,
  130, 144, 128,  130, 144, 129,  130, 144, 132,
  130, 144, 136,  130, 144, 144,  130, 144, 145,
  130, 144, 148,  130, 145, 128,  130, 145, 132,
  130, 145, 136,  130, 145, 144,  130, 145, 145,
  130, 146, 128,  130, 147, 128,  130, 147, 129,
  130, 147, 132,  130, 147, 134,  130, 147, 136,
  130, 147, 138,  130, 147, 143,  130, 147, 144,
  130, 147, 145,  130, 147, 147,  130, 147, 149,
  130, 147, 153,  130, 149, 128,  130, 149, 129,
  130, 149, 132,  130, 149, 136,  130, 149, 144,
  130, 149, 145,  130, 149, 147,  130, 149, 149,
  131, 129, 128,  131, 129, 129,  131, 129, 130,
  131, 129, 132,  131, 129, 135,  131, 129, 136,
  131, 129, 137,  131, 129, 138,  131, 129, 144,
  131, 129, 145,  131, 129, 147,  131, 129, 148,
  131, 129, 149,  131, 129, 150,  131, 129, 151,
  131, 129, 153,  131, 129, 155,  131, 130, 128,
  131, 130, 129,  131, 130, 132,  131, 130, 136,
  131, 130, 144,  131, 130, 145,  131, 130, 147,
  131, 130, 148,  131, 130, 149,  131, 131, 128,
  131, 131, 129,  131, 131, 132,  131, 131, 136,
  131, 131, 144,  131, 131, 149,  131, 133, 128,
  131, 133, 129,  131, 133, 131,  131, 133, 132,
  131, 133, 136,  131, 133, 138,  131, 133, 139,
  131, 133, 144,  131, 133, 145,  131, 133, 147,
  131, 133, 148,  131, 133, 149,  131, 133, 155,
  131, 134, 128,  131, 134, 129,  131, 134, 132,
  131, 134, 136,  131, 134, 144,  131, 134, 145,
  131, 134, 147,  131, 134, 148,  131, 134, 149,
  131, 135, 128,  131, 135, 129,  131, 135, 132,
  131, 135, 136,  131, 135, 144,  131, 135, 145,
  131, 135, 148,  131, 135, 149,  131, 135, 152,
  131, 136, 128,  131, 136, 132,  131, 137, 128,
  131, 137, 129,  131, 137, 132,  131, 137, 136,
  131, 137, 138,  131, 137, 144,  131, 137, 145,
  131, 137, 147,  131, 137, 149,  131, 137, 154,
  131, 137, 155,  131, 138, 128,  131, 138, 132,
  131, 138, 136,  131, 138, 148,  131, 140, 128,
  131, 140, 132,  131, 140, 136,  131, 140, 144,
  131, 140, 145,  131, 140, 147,  131, 141, 128,
  131, 141, 129,  131, 141, 132,  131, 141, 136,
  131, 141, 145,  131, 141, 147,  131, 141, 149,
  131, 142, 128,  131, 142, 129,  131, 142, 132,
  131, 142, 135,  131, 142, 136,  131, 142, 144,
  131, 142, 145,  131, 142, 147,  131, 142, 149,
  131, 143, 128,  131, 143, 148,  131, 144, 128,
  131, 145, 128,  131, 145, 132,  131, 145, 136,
  131, 145, 144,  131, 145, 145,  131, 146, 128,
  131, 146, 129,  131, 146, 136,  131, 146, 144,
  131, 146, 145,  131, 146, 149,  131, 147, 128,
  131, 147, 129,  131, 147, 132,  131, 147, 136,
  131, 147, 137,  131, 147, 138,  131, 147, 144,
  131, 147, 145,  131, 147, 147,  131, 147, 149,
  131, 147, 150,  131, 147, 154,  131, 148, 128,
  131, 148, 132,  131, 148, 136,  131, 149, 128,
  131, 149, 129,  131, 149, 132,  131, 149, 136,
  131, 149, 138,  131, 149, 144,  131, 149, 145,
  131, 149, 147,  131, 149, 149,  131, 149, 154,
  132, 129, 128,  132, 129, 129,  132, 129, 130,
  132, 129, 132,  132, 129, 135,  132, 129, 136,
  132, 129, 137,  132, 129, 138,  132, 129, 139,
  132, 129, 143,  132, 129, 144,  132, 129, 145,
  132, 129, 147,  132, 129, 148,  132, 129, 149,
  132, 129, 150,  132, 129, 151,  132, 129, 155,
  132, 130, 128,  132, 130, 129,  132, 130, 132,
  132, 130, 136,  132, 130, 144,  132, 130, 145,
  132, 130, 147,  132, 130, 148,  132, 130, 149,
  132, 131, 128,  132, 133, 128,  132, 133, 129,
  132, 133, 130,  132, 133, 132,  132, 133, 135,
  132, 133, 136,  132, 133, 138,  132, 133, 139,
  132, 133, 144,  132, 133, 145,  132, 133, 147,
  132, 133, 149,  132, 133, 151,  132, 133, 154,
  132, 134, 128,  132, 134, 129,  132, 134, 132,
  132, 134, 136,  132, 134, 144,  132, 134, 145,
  132, 134, 147,  132, 134, 148,  132, 134, 149,
  132, 135, 128,  132, 135, 132,  132, 135, 136,
  132, 135, 148,  132, 135, 149,  132, 136, 128,
  132, 136, 132,  132, 137, 128,  132, 137, 129,
  132, 137, 132,  132, 137, 135,  132, 137, 136,
  132, 137, 138,  132, 137, 140,  132, 137, 144,
  132, 137, 145,  132, 137, 147,  132, 137, 149,
  132, 137, 151,  132, 137, 153,  132, 138, 128,
  132, 138, 132,  132, 138, 136,  132, 139, 128,
  132, 139, 148,  132, 140, 128,  132, 140, 132,
  132, 140, 136,  132, 140, 144,  132, 140, 145,
  132, 140, 147,  132, 141, 128,  132, 142, 128,
  132, 142, 129,  132, 142, 132,  132, 142, 136,
  132, 142, 144,  132, 142, 145,  132, 142, 147,
  132, 142, 149,  132, 143, 128,  132, 143, 148,
  132, 144, 128,  132, 144, 149,  132, 145, 128,
  132, 145, 132,  132, 145, 136,  132, 145, 145,
  132, 145, 147,  132, 145, 149,  132, 146, 128,
  132, 146, 132,  132, 146, 136,  132, 146, 144,
  132, 146, 149,  132, 147, 128,  132, 147, 129,
  132, 147, 132,  132, 147, 135,  132, 147, 136,
  132, 147, 138,  132, 147, 144,  132, 147, 145,
  132, 147, 147,  132, 147, 149,  132, 148, 128,
  132, 149, 128,  132, 149, 129,  132, 149, 132,
  132, 149, 135,  132, 149, 136,  132, 149, 144,
  132, 149, 145,  132, 149, 147,  132, 149, 148,
  132, 149, 149,  132, 149, 150,  133, 129, 128,
  133, 129, 129,  133, 129, 132,  133, 129, 136,
  133, 129, 144,  133, 129, 145,  133, 129, 147,
  133, 129, 148,  133, 129, 149,  133, 129, 155,
  133, 130, 128,  133, 130, 129,  133, 130, 132,
  133, 130, 136,  133, 130, 144,  133, 130, 145,
  133, 130, 147,  133, 130, 148,  133, 130, 149,
  133, 133, 128,  133, 133, 129,  133, 133, 132,
  133, 133, 136,  133, 133, 138,  133, 133, 139,
  133, 133, 144,  133, 133, 145,  133, 133, 147,
  133, 133, 148,  133, 133, 149,  133, 133, 155,
  133, 134, 128,  133, 134, 129,  133, 134, 132,
  133, 134, 136,  133, 134, 144,  133, 134, 145,
  133, 134, 147,  133, 134, 148,  133, 134, 149,
  133, 135, 128,  133, 135, 148,  133, 137, 128,
  133, 137, 129,  133, 137, 132,  133, 137, 136,
  133, 137, 149,  133, 138, 128,  133, 138, 136,
  133, 139, 128,  133, 140, 128,  133, 140, 132,
  133, 142, 128,  133, 142, 129,  133, 142, 132,
  133, 142, 136,  133, 142, 143,  133, 142, 144,
  133, 142, 149,  133, 144, 128,  133, 145, 128,
  133, 145, 132,  133, 145, 136,  133, 145, 144,
  133, 145, 145,  133, 145, 149,  133, 147, 128,
  133, 147, 129,  133, 147, 132,  133, 147, 135,
  133, 147, 136,  133, 147, 144,  133, 147, 145,
  133, 147, 147,  133, 148, 128,  133, 148, 132,
  133, 148, 136,  133, 148, 144,  133, 148, 145,
  133, 149, 128,  133, 149, 132,  133, 149, 136,
  133, 149, 144,  133, 149, 145,  133, 149, 147,
  133, 149, 149,  134, 129, 128,  134, 129, 129,
  134, 129, 132,  134, 129, 136,  134, 129, 144,
  134, 129, 145,  134, 129, 147,  134, 129, 148,
  134, 129, 149,  134, 129, 150,  134, 129, 154,
  134, 129, 155,  134, 130, 128,  134, 130, 129,
  134, 130, 132,  134, 130, 136,  134, 130, 144,
  134, 130, 145,  134, 130, 147,  134, 130, 148,
  134, 130, 149,  134, 131, 128,  134, 131, 129,
  134, 131, 132,  134, 131, 147,  134, 131, 149,
  134, 133, 128,  134, 133, 129,  134, 133, 132,
  134, 133, 136,  134, 133, 144,  134, 133, 145,
  134, 133, 147,  134, 133, 148,  134, 133, 149,
  134, 133, 155,  134, 134, 128,  134, 134, 129,
  134, 134, 132,  134, 134, 136,  134, 134, 144,
  134, 134, 145,  134, 134, 147,  134, 134, 149,
  134, 135, 128,  134, 135, 129,  134, 135, 132,
  134, 135, 136,  134, 135, 144,  134, 135, 145,
  134, 135, 147,  134, 135, 148,  134, 135, 149,
  134, 136, 128,  134, 136, 132,  134, 136, 145,
  134, 136, 147,  134, 137, 128,  134, 137, 129,
  134, 137, 132,  134, 137, 136,  134, 137, 144,
  134, 137, 145,  134, 137, 147,  134, 137, 149,
  134, 138, 128,  134, 138, 132,  134, 138, 149,
  134, 139, 148,  134, 140, 128,  134, 140, 132,
  134, 140, 136,  134, 140, 144,  134, 140, 145,
  134, 140, 147,  134, 140, 149,  134, 141, 128,
  134, 141, 132,  134, 141, 136,  134, 141, 145,
  134, 141, 147,  134, 141, 149,  134, 142, 128,
  134, 142, 129,  134, 142, 132,  134, 142, 136,
  134, 142, 144,  134, 142, 145,  134, 142, 147,
  134, 142, 149,  134, 143, 128,  134, 143, 148,
  134, 144, 128,  134, 145, 128,  134, 145, 129,
  134, 145, 132,  134, 145, 136,  134, 145, 144,
  134, 145, 147,  134, 145, 149,  134, 146, 128,
  134, 146, 129,  134, 146, 132,  134, 146, 136,
  134, 146, 144,  134, 146, 145,  134, 146, 147,
  134, 146, 149,  134, 147, 128,  134, 147, 129,
  134, 147, 132,  134, 147, 136,  134, 147, 144,
  134, 147, 145,  134, 147, 147,  134, 147, 149,
  134, 147, 150,  134, 147, 153,  134, 147, 154,
  134, 149, 128,  134, 149, 129,  134, 149, 132,
  134, 149, 136,  134, 149, 144,  134, 149, 145,
  134, 149, 147,  134, 149, 149,  135, 129, 128,
  135, 129, 129,  135, 129, 132,  135, 129, 134,
  135, 129, 135,  135, 129, 136,  135, 129, 137,
  135, 129, 138,  135, 129, 144,  135, 129, 145,
  135, 129, 147,  135, 129, 149,  135, 129, 150,
  135, 129, 153,  135, 129, 155,  135, 130, 128,
  135, 130, 129,  135, 130, 132,  135, 130, 136,
  135, 130, 144,  135, 130, 145,  135, 130, 147,
  135, 130, 148,  135, 130, 149,  135, 130, 150,
  135, 131, 128,  135, 131, 129,  135, 131, 136,
  135, 131, 149,  135, 133, 128,  135, 133, 129,
  135, 133, 132,  135, 133, 136,  135, 133, 138,
  135, 133, 144,  135, 133, 145,  135, 133, 147,
  135, 133, 149,  135, 133, 150,  135, 133, 155,
  135, 134, 128,  135, 134, 129,  135, 134, 132,
  135, 134, 136,  135, 134, 144,  135, 134, 145,
  135, 134, 147,  135, 134, 148,  135, 134, 149,
  135, 135, 128,  135, 135, 129,  135, 135, 132,
  135, 135, 136,  135, 135, 147,  135, 135, 148,
  135, 135, 149,  135, 135, 151,  135, 136, 128,
  135, 137, 128,  135, 137, 129,  135, 137, 131,
  135, 137, 132,  135, 137, 136,  135, 137, 138,
  135, 137, 144,  135, 137, 145,  135, 137, 147,
  135, 137, 149,  135, 138, 128,  135, 138, 132,
  135, 138, 148,  135, 138, 149,  135, 140, 128,
  135, 140, 132,  135, 140, 136,  135, 140, 145,
  135, 140, 147,  135, 140, 149,  135, 141, 128,
  135, 141, 132,  135, 141, 136,  135, 141, 145,
  135, 141, 147,  135, 142, 128,  135, 142, 129,
  135, 142, 130,  135, 142, 132,  135, 142, 135,
  135, 142, 136,  135, 142, 137,  135, 142, 138,
  135, 142, 144,  135, 142, 145,  135, 142, 147,
  135, 142, 149,  135, 142, 153,  135, 142, 155,
  135, 143, 128,  135, 143, 132,  135, 143, 136,
  135, 143, 145,  135, 143, 147,  135, 144, 128,
  135, 145, 128,  135, 145, 132,  135, 145, 136,
  135, 146, 128,  135, 146, 132,  135, 146, 136,
  135, 146, 144,  135, 146, 147,  135, 147, 128,
  135, 147, 132,  135, 147, 136,  135, 147, 144,
  135, 147, 147,  135, 149, 128,  135, 149, 129,
  135, 149, 132,  135, 149, 135,  135, 149, 136,
  135, 149, 138,  135, 149, 144,  135, 149, 145,
  135, 149, 147,  135, 149, 148,  135, 149, 149,
  135, 149, 151,  135, 149, 153,  136, 129, 128,
  136, 129, 129,  136, 129, 130,  136, 129, 131,
  136, 129, 132,  136, 129, 135,  136, 129, 136,
  136, 129, 137,  136, 129, 138,  136, 129, 139,
  136, 129, 144,  136, 129, 145,  136, 129, 147,
  136, 129, 149,  136, 129, 153,  136, 130, 128,
  136, 130, 129,  136, 130, 132,  136, 130, 136,
  136, 130, 144,  136, 130, 145,  136, 130, 147,
  136, 130, 148,  136, 130, 149,  136, 130, 153,
  136, 131, 128,  136, 131, 129,  136, 131, 132,
  136, 131, 145,  136, 133, 128,  136, 133, 129,
  136, 133, 132,  136, 133, 135,  136, 133, 136,
  136, 133, 138,  136, 133, 144,  136, 133, 145,
  136, 133, 147,  136, 133, 149,  136, 133, 150,
  136, 134, 128,  136, 134, 129,  136, 134, 132,
  136, 134, 135,  136, 134, 136,  136, 134, 144,
  136, 134, 145,  136, 134, 147,  136, 134, 148,
  136, 134, 149,  136, 135, 128,  136, 135, 129,
  136, 135, 132,  136, 135, 136,  136, 135, 145,
  136, 135, 147,  136, 135, 148,  136, 135, 149,
  136, 135, 153,  136, 136, 128,  136, 136, 132,
  136, 137, 128,  136, 137, 129,  136, 137, 130,
  136, 137, 132,  136, 137, 136,  136, 137, 144,
  136, 137, 145,  136, 137, 147,  136, 137, 149,
  136, 138, 128,  136, 138, 132,  136, 138, 148,
  136, 139, 128,  136, 139, 148,  136, 140, 128,
  136, 140, 129,  136, 140, 132,  136, 140, 136,
  136, 140, 144,  136, 140, 145,  136, 141, 128,
  136, 141, 132,  136, 142, 128,  136, 142, 129,
  136, 142, 132,  136, 142, 135,  136, 142, 136,
  136, 142, 137,  136, 142, 138,  136, 142, 144,
  136, 142, 145,  136, 142, 147,  136, 142, 149,
  136, 142, 153,  136, 142, 154,  136, 143, 128,
  136, 143, 136,  136, 143, 148,  136, 144, 128,
  136, 145, 128,  136, 145, 129,  136, 145, 132,
  136, 145, 136,  136, 145, 149,  136, 146, 128,
  136, 146, 132,  136, 146, 136,  136, 146, 144,
  136, 146, 147,  136, 146, 149,  136, 147, 128,
  136, 147, 129,  136, 147, 132,  136, 147, 136,
  136, 147, 144,  136, 147, 145,  136, 147, 147,
  136, 149, 128,  136, 149, 129,  136, 149, 132,
  136, 149, 136,  136, 149, 138,  136, 149, 144,
  136, 149, 145,  136, 149, 147,  136, 149, 149,
  136, 149, 150,  136, 149, 151,  137, 129, 128,
  137, 129, 129,  137, 129, 132,  137, 129, 136,
  137, 129, 138,  137, 129, 144,  137, 129, 145,
  137, 129, 147,  137, 129, 148,  137, 129, 149,
  137, 129, 155,  137, 130, 128,  137, 130, 129,
  137, 130, 132,  137, 130, 136,  137, 130, 144,
  137, 130, 145,  137, 130, 147,  137, 130, 148,
  137, 130, 149,  137, 131, 128,  137, 131, 129,
  137, 131, 144,  137, 133, 128,  137, 133, 129,
  137, 133, 132,  137, 133, 135,  137, 133, 136,
  137, 133, 144,  137, 133, 147,  137, 133, 148,
  137, 133, 149,  137, 134, 128,  137, 134, 149,
  137, 135, 128,  137, 135, 129,  137, 135, 144,
  137, 135, 145,  137, 135, 147,  137, 135, 148,
  137, 135, 149,  137, 137, 128,  137, 137, 129,
  137, 137, 132,  137, 137, 136,  137, 137, 144,
  137, 137, 145,  137, 137, 149,  137, 140, 128,
  137, 141, 128,  137, 141, 149,  137, 142, 128,
  137, 142, 129,  137, 142, 132,  137, 142, 136,
  137, 142, 144,  137, 142, 147,  137, 142, 149,
  137, 146, 128,  137, 146, 149,  137, 147, 128,
  137, 147, 132,  137, 147, 136,  137, 147, 144,
  137, 147, 145,  137, 149, 128,  137, 149, 129,
  137, 149, 132,  137, 149, 136,  137, 149, 144,
  137, 149, 145,  137, 149, 147,  137, 149, 149,
  138, 129, 128,  138, 129, 129,  138, 129, 131,
  138, 129, 132,  138, 129, 135,  138, 129, 136,
  138, 129, 137,  138, 129, 138,  138, 129, 144,
  138, 129, 145,  138, 129, 147,  138, 129, 148,
  138, 129, 149,  138, 129, 153,  138, 130, 128,
  138, 130, 129,  138, 130, 132,  138, 130, 136,
  138, 130, 144,  138, 130, 145,  138, 130, 147,
  138, 130, 148,  138, 130, 149,  138, 131, 128,
  138, 131, 129,  138, 131, 132,  138, 131, 136,
  138, 131, 144,  138, 131, 145,  138, 131, 147,
  138, 131, 149,  138, 132, 128,  138, 132, 132,
  138, 132, 136,  138, 132, 144,  138, 132, 149,
  138, 133, 128,  138, 133, 129,  138, 133, 130,
  138, 133, 131,  138, 133, 132,  138, 133, 135,
  138, 133, 136,  138, 133, 138,  138, 133, 139,
  138, 133, 144,  138, 133, 145,  138, 133, 147,
  138, 133, 148,  138, 133, 149,  138, 133, 154,
  138, 134, 128,  138, 134, 129,  138, 134, 132,
  138, 134, 136,  138, 134, 144,  138, 134, 145,
  138, 134, 147,  138, 134, 148,  138, 134, 149,
  138, 135, 128,  138, 135, 129,  138, 135, 132,
  138, 135, 136,  138, 135, 144,  138, 135, 145,
  138, 135, 147,  138, 135, 148,  138, 135, 149,
  138, 136, 128,  138, 136, 132,  138, 136, 136,
  138, 136, 149,  138, 137, 128,  138, 137, 129,
  138, 137, 130,  138, 137, 132,  138, 137, 136,
  138, 137, 138,  138, 137, 144,  138, 137, 145,
  138, 137, 147,  138, 137, 149,  138, 137, 153,
  138, 138, 128,  138, 138, 129,  138, 138, 132,
  138, 138, 136,  138, 138, 149,  138, 139, 128,
  138, 139, 132,  138, 139, 136,  138, 139, 144,
  138, 139, 147,  138, 139, 148,  138, 140, 128,
  138, 140, 132,  138, 140, 136,  138, 140, 144,
  138, 140, 145,  138, 140, 147,  138, 141, 128,
  138, 141, 129,  138, 141, 132,  138, 141, 136,
  138, 141, 144,  138, 141, 145,  138, 141, 147,
  138, 141, 149,  138, 142, 128,  138, 142, 129,
  138, 142, 132,  138, 142, 135,  138, 142, 136,
  138, 142, 144,  138, 142, 145,  138, 142, 147,
  138, 142, 149,  138, 142, 151,  138, 142, 153,
  138, 142, 154,  138, 143, 128,  138, 143, 148,
  138, 144, 128,  138, 144, 129,  138, 144, 132,
  138, 144, 136,  138, 144, 144,  138, 144, 149,
  138, 145, 128,  138, 145, 129,  138, 145, 132,
  138, 145, 136,  138, 145, 144,  138, 145, 145,
  138, 145, 147,  138, 145, 149,  138, 146, 128,
  138, 146, 129,  138, 146, 136,  138, 146, 144,
  138, 146, 147,  138, 146, 149,  138, 147, 128,
  138, 147, 129,  138, 147, 132,  138, 147, 136,
  138, 147, 137,  138, 147, 144,  138, 147, 145,
  138, 147, 147,  138, 147, 149,  138, 149, 128,
  138, 149, 129,  138, 149, 132,  138, 149, 135,
  138, 149, 136,  138, 149, 143,  138, 149, 144,
  138, 149, 145,  138, 149, 147,  138, 149, 149,
  138, 149, 154,  139, 129, 128,  139, 129, 129,
  139, 129, 131,  139, 129, 132,  139, 129, 136,
  139, 129, 144,  139, 129, 145,  139, 129, 148,
  139, 129, 149,  139, 129, 155,  139, 130, 128,
  139, 130, 129,  139, 130, 132,  139, 130, 136,
  139, 130, 144,  139, 130, 145,  139, 130, 148,
  139, 130, 149,  139, 131, 149,  139, 133, 128,
  139, 133, 129,  139, 133, 132,  139, 133, 136,
  139, 133, 138,  139, 133, 144,  139, 133, 145,
  139, 133, 148,  139, 133, 149,  139, 134, 128,
  139, 134, 132,  139, 134, 136,  139, 136, 132,
  139, 137, 128,  139, 137, 129,  139, 137, 132,
  139, 137, 135,  139, 137, 136,  139, 137, 138,
  139, 137, 144,  139, 137, 145,  139, 137, 149,
  139, 138, 128,  139, 138, 129,  139, 138, 132,
  139, 138, 148,  139, 139, 128,  139, 139, 148,
  139, 140, 128,  139, 140, 132,  139, 140, 136,
  139, 140, 144,  139, 140, 145,  139, 141, 128,
  139, 142, 128,  139, 142, 129,  139, 142, 132,
  139, 142, 136,  139, 142, 144,  139, 142, 145,
  139, 142, 149,  139, 143, 128,  139, 143, 148,
  139, 144, 128,  139, 145, 128,  139, 145, 132,
  139, 146, 149,  139, 147, 128,  139, 147, 129,
  139, 147, 132,  139, 147, 136,  139, 147, 138,
  139, 147, 143,  139, 147, 144,  139, 147, 145,
  139, 148, 128,  139, 148, 132,  139, 148, 136,
  139, 148, 144,  139, 149, 128,  139, 149, 129,
  139, 149, 132,  139, 149, 136,  139, 149, 144,
  139, 149, 145,  139, 149, 147,  139, 149, 149,
  140, 129, 128,  140, 129, 129,  140, 129, 132,
  140, 129, 133,  140, 129, 134,  140, 129, 136,
  140, 129, 137,  140, 129, 138,  140, 129, 143,
  140, 129, 144,  140, 129, 145,  140, 129, 147,
  140, 129, 148,  140, 129, 149,  140, 129, 153,
  140, 129, 154,  140, 130, 128,  140, 130, 129,
  140, 130, 132,  140, 130, 136,  140, 130, 144,
  140, 130, 145,  140, 130, 147,  140, 130, 148,
  140, 130, 149,  140, 131, 128,  140, 131, 129,
  140, 131, 132,  140, 131, 136,  140, 131, 139,
  140, 131, 144,  140, 131, 145,  140, 131, 147,
  140, 131, 149,  140, 131, 153,  140, 131, 155,
  140, 132, 128,  140, 132, 132,  140, 132, 136,
  140, 132, 145,  140, 133, 128,  140, 133, 129,
  140, 133, 132,  140, 133, 133,  140, 133, 135,
  140, 133, 136,  140, 133, 137,  140, 133, 138,
  140, 133, 144,  140, 133, 145,  140, 133, 146,
  140, 133, 147,  140, 133, 148,  140, 133, 149,
  140, 133, 150,  140, 133, 152,  140, 133, 154,
  140, 134, 128,  140, 134, 129,  140, 134, 132,
  140, 134, 136,  140, 134, 144,  140, 134, 145,
  140, 134, 147,  140, 134, 149,  140, 135, 128,
  140, 135, 129,  140, 135, 130,  140, 135, 132,
  140, 135, 136,  140, 135, 138,  140, 135, 139,
  140, 135, 144,  140, 135, 145,  140, 135, 146,
  140, 135, 147,  140, 135, 148,  140, 135, 149,
  140, 135, 153,  140, 135, 154,  140, 135, 155,
  140, 136, 128,  140, 136, 132,  140, 136, 136,
  140, 136, 144,  140, 136, 145,  140, 136, 147,
  140, 136, 148,  140, 137, 128,  140, 137, 129,
  140, 137, 132,  140, 137, 136,  140, 137, 137,
  140, 137, 138,  140, 137, 140,  140, 137, 143,
  140, 137, 144,  140, 137, 145,  140, 137, 147,
  140, 137, 149,  140, 137, 151,  140, 138, 128,
  140, 138, 129,  140, 138, 132,  140, 138, 136,
  140, 138, 144,  140, 138, 145,  140, 138, 147,
  140, 138, 148,  140, 138, 149,  140, 139, 128,
  140, 139, 129,  140, 139, 132,  140, 139, 144,
  140, 139, 147,  140, 139, 149,  140, 140, 128,
  140, 140, 129,  140, 140, 132,  140, 140, 136,
  140, 140, 144,  140, 140, 145,  140, 140, 147,
  140, 140, 149,  140, 141, 128,  140, 141, 129,
  140, 141, 132,  140, 141, 136,  140, 141, 144,
  140, 141, 145,  140, 141, 147,  140, 141, 149,
  140, 142, 128,  140, 142, 129,  140, 142, 132,
  140, 142, 136,  140, 142, 137,  140, 142, 138,
  140, 142, 144,  140, 142, 145,  140, 142, 147,
  140, 142, 149,  140, 143, 128,  140, 143, 129,
  140, 143, 132,  140, 143, 136,  140, 143, 144,
  140, 143, 145,  140, 143, 148,  140, 143, 149,
  140, 144, 128,  140, 144, 129,  140, 144, 132,
  140, 144, 136,  140, 144, 144,  140, 144, 145,
  140, 144, 149,  140, 145, 128,  140, 145, 129,
  140, 145, 132,  140, 145, 136,  140, 145, 144,
  140, 145, 145,  140, 145, 147,  140, 145, 149,
  140, 146, 128,  140, 146, 129,  140, 146, 132,
  140, 146, 136,  140, 146, 144,  140, 146, 145,
  140, 146, 147,  140, 146, 149,  140, 146, 151,
  140, 147, 128,  140, 147, 129,  140, 147, 132,
  140, 147, 136,  140, 147, 142,  140, 147, 144,
  140, 147, 145,  140, 147, 147,  140, 147, 149,
  140, 147, 150,  140, 147, 151,  140, 147, 152,
  140, 147, 153,  140, 147, 154,  140, 147, 155,
  140, 148, 128,  140, 148, 132,  140, 148, 136,
  140, 148, 144,  140, 148, 147,  140, 149, 128,
  140, 149, 129,  140, 149, 132,  140, 149, 136,
  140, 149, 137,  140, 149, 138,  140, 149, 143,
  140, 149, 144,  140, 149, 145,  140, 149, 147,
  140, 149, 148,  140, 149, 149,  140, 149, 150,
  140, 149, 154,  141, 129, 128,  141, 129, 129,
  141, 129, 132,  141, 129, 134,  141, 129, 135,
  141, 129, 136,  141, 129, 138,  141, 129, 144,
  141, 129, 145,  141, 129, 147,  141, 129, 148,
  141, 129, 149,  141, 129, 150,  141, 130, 128,
  141, 130, 129,  141, 130, 132,  141, 130, 136,
  141, 130, 144,  141, 130, 145,  141, 130, 147,
  141, 130, 148,  141, 130, 149,  141, 131, 128,
  141, 131, 129,  141, 131, 132,  141, 131, 134,
  141, 131, 136,  141, 131, 144,  141, 131, 149,
  141, 132, 128,  141, 132, 132,  141, 132, 136,
  141, 133, 128,  141, 133, 129,  141, 133, 132,
  141, 133, 136,  141, 133, 138,  141, 133, 144,
  141, 133, 145,  141, 133, 147,  141, 133, 149,
  141, 133, 150,  141, 134, 128,  141, 134, 129,
  141, 134, 132,  141, 134, 136,  141, 134, 144,
  141, 134, 145,  141, 134, 147,  141, 134, 149,
  141, 135, 128,  141, 135, 132,  141, 135, 136,
  141, 135, 144,  141, 135, 145,  141, 135, 148,
  141, 135, 149,  141, 136, 128,  141, 137, 128,
  141, 137, 129,  141, 137, 132,  141, 137, 136,
  141, 137, 138,  141, 137, 144,  141, 137, 145,
  141, 137, 147,  141, 137, 149,  141, 137, 150,
  141, 137, 151,  141, 137, 155,  141, 138, 128,
  141, 138, 129,  141, 138, 136,  141, 138, 145,
  141, 138, 147,  141, 138, 149,  141, 139, 128,
  141, 139, 148,  141, 139, 149,  141, 140, 128,
  141, 140, 132,  141, 140, 136,  141, 140, 144,
  141, 140, 145,  141, 140, 147,  141, 140, 149,
  141, 141, 128,  141, 141, 129,  141, 141, 132,
  141, 141, 149,  141, 142, 128,  141, 142, 129,
  141, 142, 132,  141, 142, 136,  141, 142, 137,
  141, 142, 138,  141, 142, 144,  141, 142, 145,
  141, 142, 147,  141, 142, 149,  141, 143, 128,
  141, 143, 148,  141, 144, 128,  141, 145, 128,
  141, 145, 129,  141, 145, 132,  141, 145, 136,
  141, 145, 144,  141, 145, 145,  141, 145, 147,
  141, 146, 128,  141, 146, 132,  141, 146, 136,
  141, 146, 144,  141, 147, 128,  141, 147, 129,
  141, 147, 132,  141, 147, 136,  141, 147, 144,
  141, 147, 145,  141, 147, 147,  141, 147, 149,
  141, 149, 128,  141, 149, 129,  141, 149, 132,
  141, 149, 135,  141, 149, 136,  141, 149, 138,
  141, 149, 144,  141, 149, 145,  141, 149, 147,
  141, 149, 149,  141, 149, 150,  141, 149, 153,
  141, 149, 154,  142, 129, 128,  142, 129, 129,
  142, 129, 132,  142, 129, 134,  142, 129, 136,
  142, 129, 139,  142, 129, 144,  142, 129, 145,
  142, 129, 147,  142, 129, 148,  142, 129, 149,
  142, 130, 128,  142, 130, 129,  142, 130, 132,
  142, 130, 136,  142, 130, 144,  142, 130, 145,
  142, 130, 147,  142, 130, 148,  142, 130, 149,
  142, 131, 128,  142, 131, 132,  142, 131, 149,
  142, 133, 128,  142, 133, 129,  142, 133, 132,
  142, 133, 136,  142, 133, 144,  142, 133, 145,
  142, 133, 147,  142, 133, 148,  142, 133, 149,
  142, 134, 128,  142, 134, 149,  142, 135, 128,
  142, 135, 148,  142, 137, 128,  142, 137, 129,
  142, 137, 132,  142, 137, 136,  142, 137, 144,
  142, 137, 145,  142, 137, 147,  142, 137, 149,
  142, 137, 151,  142, 138, 128,  142, 138, 129,
  142, 138, 136,  142, 138, 148,  142, 139, 128,
  142, 139, 148,  142, 140, 128,  142, 140, 132,
  142, 140, 136,  142, 140, 144,  142, 140, 145,
  142, 141, 149,  142, 142, 128,  142, 142, 129,
  142, 142, 132,  142, 142, 136,  142, 142, 144,
  142, 142, 145,  142, 142, 149,  142, 143, 128,
  142, 143, 148,  142, 143, 149,  142, 145, 128,
  142, 146, 128,  142, 147, 128,  142, 147, 144,
  142, 147, 147,  142, 147, 149,  142, 149, 128,
  142, 149, 129,  142, 149, 132,  142, 149, 136,
  142, 149, 144,  142, 149, 145,  142, 149, 149,
  142, 149, 150,  142, 149, 155,  143, 129, 128,
  143, 129, 129,  143, 129, 132,  143, 129, 134,
  143, 129, 136,  143, 129, 144,  143, 129, 145,
  143, 129, 147,  143, 129, 148,  143, 129, 149,
  143, 129, 150,  143, 130, 128,  143, 130, 129,
  143, 130, 132,  143, 130, 136,  143, 130, 144,
  143, 130, 145,  143, 130, 147,  143, 130, 148,
  143, 130, 149,  143, 131, 128,  143, 131, 132,
  143, 131, 134,  143, 131, 136,  143, 131, 144,
  143, 131, 149,  143, 133, 128,  143, 133, 129,
  143, 133, 132,  143, 133, 136,  143, 133, 144,
  143, 133, 145,  143, 133, 147,  143, 133, 148,
  143, 133, 149,  143, 134, 128,  143, 134, 129,
  143, 134, 132,  143, 134, 136,  143, 134, 144,
  143, 134, 145,  143, 134, 147,  143, 134, 149,
  143, 135, 128,  143, 135, 132,  143, 135, 148,
  143, 136, 128,  143, 136, 132,  143, 136, 149,
  143, 137, 128,  143, 137, 129,  143, 137, 132,
  143, 137, 136,  143, 137, 144,  143, 137, 145,
  143, 137, 147,  143, 137, 149,  143, 138, 128,
  143, 138, 132,  143, 138, 136,  143, 138, 149,
  143, 140, 128,  143, 140, 132,  143, 140, 136,
  143, 140, 144,  143, 140, 145,  143, 140, 147,
  143, 140, 149,  143, 141, 128,  143, 141, 144,
  143, 142, 128,  143, 142, 129,  143, 142, 132,
  143, 142, 136,  143, 142, 144,  143, 142, 145,
  143, 142, 147,  143, 142, 149,  143, 143, 128,
  143, 143, 148,  143, 144, 128,  143, 144, 132,
  143, 145, 128,  143, 145, 132,  143, 145, 136,
  143, 145, 144,  143, 145, 145,  143, 145, 147,
  143, 145, 149,  143, 146, 128,  143, 146, 132,
  143, 146, 136,  143, 146, 144,  143, 146, 149,
  143, 147, 128,  143, 147, 129,  143, 147, 132,
  143, 147, 136,  143, 147, 144,  143, 147, 145,
  143, 147, 147,  143, 147, 149,  143, 149, 128,
  143, 149, 129,  143, 149, 132,  143, 149, 135,
  143, 149, 136,  143, 149, 137,  143, 149, 144,
  143, 149, 145,  143, 149, 147,  143, 149, 149,
  144, 129, 128,  144, 129, 129,  144, 129, 132,
  144, 129, 136,  144, 129, 144,  144, 129, 145,
  144, 129, 147,  144, 129, 149,  144, 130, 128,
  144, 130, 129,  144, 130, 132,  144, 130, 136,
  144, 130, 144,  144, 130, 145,  144, 130, 147,
  144, 130, 148,  144, 130, 149,  144, 131, 128,
  144, 131, 129,  144, 131, 149,  144, 133, 128,
  144, 133, 129,  144, 133, 132,  144, 133, 135,
  144, 133, 136,  144, 133, 144,  144, 133, 145,
  144, 133, 147,  144, 133, 148,  144, 133, 149,
  144, 134, 128,  144, 134, 129,  144, 134, 132,
  144, 134, 136,  144, 134, 144,  144, 134, 145,
  144, 134, 147,  144, 134, 149,  144, 135, 128,
  144, 135, 132,  144, 135, 136,  144, 135, 144,
  144, 135, 145,  144, 135, 147,  144, 135, 148,
  144, 135, 149,  144, 136, 128,  144, 137, 128,
  144, 137, 129,  144, 137, 132,  144, 137, 136,
  144, 137, 144,  144, 137, 145,  144, 137, 147,
  144, 137, 149,  144, 138, 128,  144, 138, 129,
  144, 138, 132,  144, 138, 136,  144, 138, 144,
  144, 138, 149,  144, 139, 128,  144, 139, 149,
  144, 140, 128,  144, 140, 136,  144, 141, 128,
  144, 142, 128,  144, 142, 129,  144, 142, 132,
  144, 142, 136,  144, 142, 144,  144, 142, 145,
  144, 142, 147,  144, 142, 149,  144, 143, 128,
  144, 143, 132,  144, 143, 136,  144, 143, 149,
  144, 144, 128,  144, 144, 149,  144, 145, 128,
  144, 145, 129,  144, 145, 132,  144, 145, 136,
  144, 145, 144,  144, 145, 145,  144, 145, 147,
  144, 145, 149,  144, 146, 128,  144, 146, 132,
  144, 146, 136,  144, 146, 144,  144, 147, 128,
  144, 147, 129,  144, 147, 132,  144, 147, 136,
  144, 147, 144,  144, 147, 145,  144, 147, 149,
  144, 149, 128,  144, 149, 129,  144, 149, 132,
  144, 149, 136,  144, 149, 144,  144, 149, 145,
  144, 149, 147,  144, 149, 149,  145, 129, 128,
  145, 129, 129,  145, 129, 132,  145, 129, 136,
  145, 129, 137,  145, 129, 144,  145, 129, 145,
  145, 129, 147,  145, 129, 148,  145, 129, 149,
  145, 130, 128,  145, 130, 129,  145, 130, 132,
  145, 130, 136,  145, 130, 144,  145, 130, 145,
  145, 130, 147,  145, 130, 148,  145, 130, 149,
  145, 131, 128,  145, 131, 149,  145, 133, 128,
  145, 133, 129,  145, 133, 132,  145, 133, 136,
  145, 133, 138,  145, 133, 144,  145, 133, 145,
  145, 133, 147,  145, 133, 148,  145, 133, 149,
  145, 134, 128,  145, 134, 129,  145, 134, 132,
  145, 134, 136,  145, 134, 144,  145, 134, 145,
  145, 134, 147,  145, 134, 149,  145, 135, 128,
  145, 135, 132,  145, 135, 148,  145, 136, 128,
  145, 136, 132,  145, 137, 128,  145, 137, 129,
  145, 137, 132,  145, 137, 136,  145, 137, 144,
  145, 137, 145,  145, 137, 147,  145, 137, 149,
  145, 137, 154,  145, 138, 128,  145, 138, 132,
  145, 139, 128,  145, 140, 128,  145, 140, 132,
  145, 140, 147,  145, 140, 149,  145, 141, 128,
  145, 142, 128,  145, 142, 129,  145, 142, 132,
  145, 142, 136,  145, 142, 144,  145, 142, 145,
  145, 142, 147,  145, 142, 149,  145, 143, 128,
  145, 143, 148,  145, 144, 128,  145, 145, 128,
  145, 145, 129,  145, 145, 132,  145, 145, 136,
  145, 145, 144,  145, 145, 145,  145, 145, 149,
  145, 146, 128,  145, 146, 132,  145, 146, 136,
  145, 146, 144,  145, 146, 149,  145, 147, 128,
  145, 147, 129,  145, 147, 132,  145, 147, 135,
  145, 147, 136,  145, 147, 138,  145, 147, 144,
  145, 147, 145,  145, 147, 147,  145, 148, 128,
  145, 148, 132,  145, 148, 136,  145, 148, 144,
  145, 148, 145,  145, 149, 128,  145, 149, 129,
  145, 149, 132,  145, 149, 136,  145, 149, 144,
  145, 149, 145,  145, 149, 147,  145, 149, 149,
  146, 129, 128,  146, 129, 129,  146, 129, 130,
  146, 129, 132,  146, 129, 136,  146, 129, 138,
  146, 129, 144,  146, 129, 145,  146, 129, 147,
  146, 129, 148,  146, 129, 149,  146, 129, 153,
  146, 130, 128,  146, 130, 129,  146, 130, 132,
  146, 130, 136,  146, 130, 144,  146, 130, 145,
  146, 130, 147,  146, 130, 148,  146, 130, 149,
  146, 131, 128,  146, 131, 129,  146, 133, 128,
  146, 133, 129,  146, 133, 132,  146, 133, 136,
  146, 133, 144,  146, 133, 145,  146, 133, 147,
  146, 133, 148,  146, 133, 149,  146, 134, 128,
  146, 134, 129,  146, 134, 132,  146, 134, 136,
  146, 134, 144,  146, 134, 145,  146, 134, 147,
  146, 134, 149,  146, 135, 128,  146, 135, 132,
  146, 135, 136,  146, 135, 144,  146, 135, 145,
  146, 135, 148,  146, 135, 149,  146, 136, 128,
  146, 136, 136,  146, 136, 145,  146, 136, 147,
  146, 137, 128,  146, 137, 129,  146, 137, 132,
  146, 137, 136,  146, 137, 144,  146, 137, 145,
  146, 137, 147,  146, 137, 149,  146, 138, 128,
  146, 138, 149,  146, 140, 128,  146, 140, 132,
  146, 141, 128,  146, 141, 132,  146, 141, 136,
  146, 141, 145,  146, 141, 147,  146, 142, 128,
  146, 142, 129,  146, 142, 132,  146, 142, 135,
  146, 142, 136,  146, 142, 138,  146, 142, 144,
  146, 142, 145,  146, 142, 147,  146, 142, 149,
  146, 143, 128,  146, 143, 149,  146, 145, 128,
  146, 145, 132,  146, 145, 136,  146, 145, 144,
  146, 145, 147,  146, 146, 128,  146, 146, 132,
  146, 146, 136,  146, 146, 144,  146, 146, 147,
  146, 146, 149,  146, 147, 128,  146, 147, 132,
  146, 147, 136,  146, 147, 144,  146, 147, 145,
  146, 147, 147,  146, 149, 128,  146, 149, 129,
  146, 149, 132,  146, 149, 136,  146, 149, 144,
  146, 149, 145,  146, 149, 147,  146, 149, 149,
  147, 129, 128,  147, 129, 129,  147, 129, 132,
  147, 129, 136,  147, 129, 141,  147, 129, 144,
  147, 129, 145,  147, 129, 147,  147, 129, 149,
  147, 130, 128,  147, 130, 129,  147, 130, 132,
  147, 130, 136,  147, 130, 144,  147, 130, 145,
  147, 130, 147,  147, 130, 148,  147, 130, 149,
  147, 131, 128,  147, 131, 149,  147, 133, 128,
  147, 133, 129,  147, 133, 132,  147, 133, 136,
  147, 133, 138,  147, 133, 144,  147, 133, 145,
  147, 133, 147,  147, 133, 149,  147, 134, 128,
  147, 134, 129,  147, 134, 132,  147, 134, 136,
  147, 134, 144,  147, 134, 145,  147, 134, 147,
  147, 134, 149,  147, 135, 128,  147, 135, 129,
  147, 135, 132,  147, 135, 136,  147, 135, 144,
  147, 135, 145,  147, 135, 147,  147, 135, 148,
  147, 135, 149,  147, 136, 128,  147, 136, 132,
  147, 136, 136,  147, 136, 145,  147, 137, 128,
  147, 137, 129,  147, 137, 132,  147, 137, 136,
  147, 137, 141,  147, 137, 144,  147, 137, 145,
  147, 137, 147,  147, 137, 149,  147, 137, 153,
  147, 138, 128,  147, 138, 129,  147, 138, 132,
  147, 138, 136,  147, 138, 147,  147, 138, 149,
  147, 139, 128,  147, 139, 129,  147, 139, 132,
  147, 139, 147,  147, 139, 149,  147, 140, 128,
  147, 140, 129,  147, 140, 132,  147, 140, 136,
  147, 140, 145,  147, 140, 147,  147, 140, 149,
  147, 141, 128,  147, 141, 132,  147, 141, 136,
  147, 141, 145,  147, 141, 147,  147, 142, 128,
  147, 142, 129,  147, 142, 132,  147, 142, 136,
  147, 142, 141,  147, 142, 144,  147, 142, 147,
  147, 142, 149,  147, 143, 128,  147, 143, 132,
  147, 143, 136,  147, 143, 144,  147, 143, 149,
  147, 144, 128,  147, 144, 129,  147, 144, 132,
  147, 144, 136,  147, 144, 149,  147, 145, 128,
  147, 145, 129,  147, 145, 132,  147, 145, 136,
  147, 145, 144,  147, 145, 145,  147, 145, 147,
  147, 145, 149,  147, 146, 128,  147, 146, 129,
  147, 146, 132,  147, 146, 136,  147, 146, 144,
  147, 146, 147,  147, 146, 149,  147, 147, 128,
  147, 147, 129,  147, 147, 132,  147, 147, 134,
  147, 147, 135,  147, 147, 136,  147, 147, 137,
  147, 147, 144,  147, 147, 145,  147, 147, 147,
  147, 147, 149,  147, 147, 153,  147, 148, 128,
  147, 148, 132,  147, 148, 136,  147, 148, 144,
  147, 148, 145,  147, 148, 149,  147, 149, 128,
  147, 149, 129,  147, 149, 132,  147, 149, 136,
  147, 149, 144,  147, 149, 145,  147, 149, 147,
  147, 149, 149,
};

static unsigned short ks_table2[][4] = {
  0xa4bf, 128, 129, 128,  0xa4c0, 128, 130, 128,
  0xa4c1, 128, 131, 128,  0xa4c2, 128, 132, 128,
  0xa4c3, 128, 133, 128,  0xa4c4, 128, 134, 128,
  0xa4c5, 128, 135, 128,  0xa4c6, 128, 136, 128,
  0xa4c7, 128, 137, 128,  0xa4c8, 128, 138, 128,
  0xa4c9, 128, 139, 128,  0xa4ca, 128, 140, 128,
  0xa4cb, 128, 141, 128,  0xa4cc, 128, 142, 128,
  0xa4cd, 128, 143, 128,  0xa4ce, 128, 144, 128,
  0xa4cf, 128, 145, 128,  0xa4d0, 128, 146, 128,
  0xa4d1, 128, 147, 128,  0xa4d2, 128, 148, 128,
  0xa4d3, 128, 149, 128,  0xa4a1, 129, 128, 128,
  0xa4a2, 130, 128, 128,  0xa4a4, 131, 128, 128,
  0xa4a7, 132, 128, 128,  0xa4a8, 133, 128, 128,
  0xa4a9, 134, 128, 128,  0xa4b1, 135, 128, 128,
  0xa4b2, 136, 128, 128,  0xa4b3, 137, 128, 128,
  0xa4b5, 138, 128, 128,  0xa4b6, 139, 128, 128,
  0xa4b7, 140, 128, 128,  0xa4b8, 141, 128, 128,
  0xa4b9, 142, 128, 128,  0xa4ba, 143, 128, 128,
  0xa4bb, 144, 128, 128,  0xa4bc, 145, 128, 128,
  0xa4bd, 146, 128, 128,  0xa4be, 147, 128, 128,
};

static int fcon_map1[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1, 2, 4, 4,
			  4, 2, 1, 3, 0};
static int fcon_map2[] = {5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 8, 8, 8, 6, 7, 9, 9,
			  9, 7, 6, 8, 5};
static int vow_base[] = {0, 311, 314, 317, 320, 323, 326, 329, 332, 335, 339,
			 343, 347, 351, 355, 358, 361, 364, 367, 370, 374, 378};
static int vow_kind[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0,
			 0, 0, 1, 1, 0};
static int lcon_kind[] = {0, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
			  1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
static int lcon_map[] = {0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0, 0, 0, 3, 3, 1, 1,
			 1, 3, 3, 0, 1};

convert_3_to_ks(f, m, l, des)
    int f, m, l;
    unsigned char *des;
{
    unsigned char key[3];
    register int hi, lo, mi, result, found;

    key[0] = f;
    key[1] = m;
    key[2] = l;
    lo = 0;
    hi = sizeof(ks_table1)/3 - 1;
    found = 0;
    while (lo + 1 < hi) {
	mi = (lo + hi)/2;
	result = strncmp(ks_table1[mi], key, 3);
	if (result == 0) {
	    found = 1;
	    break;
	}
	else if (result > 0) {
	    hi = mi;
	}
	else {
	    lo = mi;
	}
    }
    if (!found) {
	if (!strncmp(ks_table1[lo], key, 3)) {
	    found = 1;
	    mi = lo;
	}
	if (!strncmp(ks_table1[hi], key, 3)) {
	    found = 1;
	    mi = hi;
	}
    }
    if (!found) {
	for (mi = 0; mi < 40; mi++)
	    if (ks_table2[mi][1] == f && ks_table2[mi][2] == m &&
		ks_table2[mi][3] == l) {
		des[0] = ks_table2[mi][0] >> 8;
		des[1] = ks_table2[mi][0];
		return 1;	/* found */
	    }
	des[0] = 0xa1;
	des[1] = 0xe0;
	return 0;		/* not found */
    }
    else {
	des[0] = mi / (0xff-0xa1) + 0xb0;
	des[1] = mi % (0xff-0xa1) + 0xa1;
	return 1;		/* found */
    }
}
