; -*- Mode: Emacs-Lisp -*-
;
; hangul-mode.el - nemacs  ѱ ֱ α׷Դϴ.
; ̻  ߰Ͻø jksong@cosmos.kaist.ac.kr  ֽñ ٶϴ.
;
(provide 'hangul-mode)

(defvar hangul-automata-name "hanauto"
  "* ѱ 丶Ÿ ϴ α׷ ̸Դϴ.")
(defvar hangul-process-name "*hanauto*"
  "* ѱ 丶Ÿ ϴ μ ̸Դϴ.")
(defvar hangul-mode nil
  "* Emacs ѱ  ƴ Ÿ 
nil ƴϸ ѱ Դϴ.")
(defvar hangul-mode-map nil
  "* ѱ 忡 ̴ ŰԴϴ.")
(defvar non-hangul-mode-map nil
  "* ѱ   Ű ϱ  ̴ ŰԴϴ.")
(defvar last-hangul-cmd ?i
  "* ѱ 丶Ÿ μ   Դϴ.
i  ̶ ̰ d  ǥö Դϴ.")

(set-default
 'mode-line-format
 '((hangul-mode "ѱ" "----")		; ѱ Ǵ ----
   mode-line-modified			; -- Ǵ **
   mode-line-nemacs-header		; N Ǵ -
   mode-line-buffer-identification	; "Emacs: %17b"
   "   "
   global-mode-string
   "  %[("
   (kanji-flag ("%c" ":"))
   mode-name
   minor-mode-alist
   "%n"
   mode-line-process
   ")%]--"
   (-3 . "%p")
   "-%-"))

(defun initialize-hangul-mode ()
  "ѱ 丶Ÿ μ \\{hangul-automata-name}  ŵϴ."
  (setq hangul-process
	(start-process hangul-process-name nil hangul-automata-name))
  (process-kill-without-query hangul-process)
  (set-process-filter hangul-process 'hangul-filter))

(defun toggle-hangul-mode (arg)
  "ѱ۸带 ȯմϴ."
  (interactive "p")
  (setq hangul-mode (not hangul-mode))
  (if hangul-mode
      (progn
	(setq non-hangul-mode-map (current-global-map))
	(setq hangul-mode-map (copy-keymap (current-global-map)))
	(mapcar (function
		 (lambda (key) (define-key
				 hangul-mode-map
				 key
				 'hangul-self-insert)))
		(where-is-internal
		 (if (and (boundp 'EGG) EGG)
		     'egg-self-insert-command
		   'self-insert-command)
		 nil nil))
	(use-global-map hangul-mode-map))
    (use-global-map non-hangul-mode-map))
  (send-string hangul-process "t\n")	       ; ѿ ȯ
  (setq last-hangul-cmd ?i)
  (set-buffer-modified-p (buffer-modified-p))) ; ̷ ǥ  ٲϴ.

(defun hangul-self-insert (arg)
  " ڸ ARG  ŭ մϴ."
  (interactive "p")
  (if (eq last-command 'hangul-self-insert)
      ()
    (send-string hangul-process "r\n")
    (setq last-hangul-cmd ?i))		       ; 丶 ٽ 
  (let ((i 0))
    (while (< i arg)
      (send-string hangul-process (format "i%c\n" last-input-char))
      (setq i (1+ i)))))

(defun hangul-filter (proc buf)
  "ѱ 丶Ÿ  Ʈ óϴ  մϴ."
  (if (= last-hangul-cmd ?d)
      (backward-delete-char 1))
  (while (> (length buf) 1)
    (let ((i 0))
      (while (not (= (aref buf i) ?\n))
	(setq i (1+ i)))
      (setq str (substring buf 1 i))
      (insert str)
      (if (and (= (aref buf (1- i)) ? ) (> (current-column) fill-column))
	  (run-hooks 'auto-fill-hook))
      (setq last-hangul-cmd (aref buf 0))
      (setq buf (substring buf (1+ i))))))

;  ̿ ° ġʽÿ.
;
(define-key global-map "\M- "     'toggle-hangul-mode)

(initialize-hangul-mode)
